
#!/usr/bin/env tclsh

# 递归函数，用于查找 .v 文件
proc find_v_files {dir} {
    set file_list {}

    # 获取当前目录中的所有文件和子目录
    foreach file [glob -nocomplain -directory $dir *] {
        # 如果是目录，递归调用函数
        if {[file isdirectory $file]} {
            lappend file_list [find_v_files $file]
        } elseif {[string match *.v $file]} {
            # 如果是 .v 文件，添加到列表
            lappend file_list [file normalize $file]
        }
    }

    return $file_list
}

# 获取当前路径
set current_path [pwd]

# 查找当前路径及其子目录下的所有 .v 文件
set all_v_files [find_v_files $current_path/rtl_code]

# 打开输出文件
set outfile "./setup/filelist.tcl"
set fp [open $outfile "w"]

# 将绝对路径逐行写入输出文件
foreach file $all_v_files {
    if {[string first ".v" $file] >= 0} {
        puts $fp $file  ;# 将每个路径写入文件
    }
}

# 关闭文件
close $fp

