set DATE [exec date "+%Y%m%d_%H%M"]

 # 设定文件列表的路径和输出文件的路径
 set filelist_path "./setup/filelist.tcl"
 set output_path "./work/script.tcl"

 # 打开输入文件
 set in_file [open $filelist_path "r"]

 # 打开输出文件
 set out_file [open $output_path "a"]

puts $out_file "########READ_DESIGN########"
 
 # 读取输入文件的每一行
while {[gets $in_file line] >= 0} {
    # 去掉每行的前后空白
    set line [string trim $line]

    # 移除行首和行尾的花括号
    set line [string trim $line "{}"]

    # 将这一行按空格拆分成文件路径列表
    set file_list [split $line " "]

    # 逐个遍历每个 .v 文件
    foreach file_path $file_list {
        # 检查文件是否以 .v 结尾
        if {[string match "*.v" $file_path]} {
            # 将命令写入输出文件
            puts $out_file "analyze -format verilog $file_path"
        }
    }
}
set chan [open ./setup/library.lst r]
set line_num 0
while {[gets $chan line] >= 0} {
    if { ![string match "#*" $line]} {
   incr line_num
       if { $line_num == 3  } {
       set line [string trim $line]     
   # 第三行设置 top 名称
       set TOP_NAME $line
       puts $out_file "elaborate $TOP_NAME"
       puts $out_file "current_design $TOP_NAME"
       puts $out_file "uniquify -force "
       puts $out_file "check_design"
       puts $out_file "link"
       puts $out_file "write_file -format ddc -hierarchy -output ../output/${TOP_NAME}_${DATE}_link.ddc"
            }
}
}
# 关闭文件
close $in_file
close $chan
close $out_file

                                                                
                  