###########file#########
set chan [open ./setup/clock.lst r]
set line_num 0
set outfile "./work/script.tcl"
set fp_write [open $outfile a]



# 初始化 CKNAME 列表
set CKNAME_list {}
set CKPORT_list {}

########CONSTRAINS#########
while {[gets $chan line] >= 0} {
   if { ![string match "#*" $line]} { 
     set CKNAME  [lindex $line 0]
     set PRD     [lindex $line 1]
     set R       [lindex $line 2]
     set F       [lindex $line 3]
     set CKPORT  [lindex $line 4]
     #set C_CLK   [lindex $line 5]

set CLK_SKEW              	[expr $PRD*0.05]
set CLK_SOURCE_LATENCY   	[expr $PRD*0.1]    
set CLK_NETWORK_LATENCY   	[expr $PRD*0.1]  
set CLK_TRAN             	[expr $PRD*0.01]
set INPUT_DELAY_MAX             [expr $PRD*0.4]
set INPUT_DELAY_MIN             0
set OUTPUT_DELAY_MAX            [expr $PRD*0.4]
set OUTPUT_DELAY_MIN            0
     puts "----------------clk------------------"
     puts "Clock: $CKNAME"
     puts "prd_val: ${PRD}"

     if {[string first "/" $CKPORT] >= 0} {
        # If $CKPORT contains '/', modify the puts statements
        puts $fp_write "########CLOCK#########"
        puts $fp_write "create_clock -name $CKNAME    \[get_pins -hierarchical $CKPORT\] -period $PRD -waveform \[list $R $F\]"
        puts $fp_write "set_dont_touch_network    \[get_pins -hierarchical $CKPORT\]"
        puts $fp_write "set_ideal_network -no_propagate    \[get_pins -hierarchical $CKPORT\]"
   
     } else {
        # Default case
        puts $fp_write "########CLOCK#########"
        puts $fp_write "remove_driving_cell      \[get_ports $CKPORT\]" 
        puts $fp_write "set_drive       0        \[get_ports $CKPORT\]"
        puts $fp_write "create_clock -name $CKNAME    \[get_ports $CKPORT\] -period $PRD -waveform   \[list $R $F\]"
        puts $fp_write "set_dont_touch_network    $CKNAME"
        puts $fp_write "set_ideal_network -no_propagate    \[get_ports $CKPORT\]"
        lappend CKPORT_list $CKPORT
   
     }


     puts $fp_write "########SKEW & LATENCY#########"
     puts $fp_write "set_clock_uncertainty          $CLK_SKEW           \[get_clocks $CKNAME\]"
     puts $fp_write "set_clock_latency -source -max $CLK_SOURCE_LATENCY   	  	\[get_clocks $CKNAME\]"
     puts $fp_write "set_clock_latency    -max      $CLK_NETWORK_LATENCY      	\[get_clocks $CKNAME\]"
     puts $fp_write "set_clock_transition -max      $CLK_TRAN           	\[get_clocks $CKNAME\]"

    
     lappend clocklist $CKNAME
     lappend CKNAME_list $CKNAME
     
     #puts $clocklist
     incr line_num


   }
} 

     puts ""
     puts "INFO :  CKNAME_list : $CKNAME_list"
     puts "INFO :  CKPORT_list : $CKPORT_list"
     puts ""

close $chan
if {[llength $CKNAME_list] > 2} {
     puts $fp_write "########FLASE_PATH#########"
# 生成所有 CKNAME 两两组合的 set_false_path 语句
    for {set i 0} {$i < [llength $CKNAME_list]} {incr i} {
        for {set j [expr {$i + 1}]} {$j < [llength $CKNAME_list]} {incr j} {
            set from_clk [lindex $CKNAME_list $i]
            set to_clk [lindex $CKNAME_list $j]
            puts $fp_write "set_false_path -from \[get_clocks $from_clk\] -to \[get_clocks $to_clk\]"
            puts $fp_write "set_false_path -from \[get_clocks $to_clk\] -to \[get_clocks $from_clk\]"
        }
    }
}
close $fp_write
