########PRE########
set_host_options -max_cores 16
set_svf  ../output/aes_cipher_top_20240911_1100.svf
set_app_var  search_path   "../lib" 
set_app_var  target_library   "sky130_fd_sc_hd__tt_025C_1v80.db " 
set_app_var  link_library     "* sky130_fd_sc_hd__tt_025C_1v80.db" 
set top  aes_cipher_top 
########READ_DESIGN########
analyze -format verilog /home/eda/hwt/SYN_FLOW/rtl_code/aes_core/timescale.v
analyze -format verilog /home/eda/hwt/SYN_FLOW/rtl_code/aes_core/aes_sbox.v
analyze -format verilog /home/eda/hwt/SYN_FLOW/rtl_code/aes_core/aes_rcon.v
analyze -format verilog /home/eda/hwt/SYN_FLOW/rtl_code/aes_core/aes_key_expand_128.v
analyze -format verilog /home/eda/hwt/SYN_FLOW/rtl_code/aes_core/aes_cipher_top.v
elaborate aes_cipher_top
current_design aes_cipher_top
uniquify -force 
check_design
link
write_file -format ddc -hierarchy -output ../output/aes_cipher_top_20240911_1100_link.ddc
########CLOCK#########
remove_driving_cell      [get_ports clk]
set_drive       0        [get_ports clk]
create_clock -name clk    [get_ports clk] -period 10 -waveform   [list 0 5]
set_dont_touch_network    clk
set_ideal_network -no_propagate    [get_ports clk]
########SKEW & LATENCY#########
set_clock_uncertainty          0.5           [get_clocks clk]
set_clock_latency -source -max 1.0   	  	[get_clocks clk]
set_clock_latency    -max      1.0      	[get_clocks clk]
set_clock_transition -max      0.1           	[get_clocks clk]
########SET_RST########
set_dont_touch_network 				[get_ports rst]
set_false_path -from   				[get_ports rst]
set_ideal_network -no_propagate     [get_ports rst]
set_drive 0            				[get_ports rst]
########IO DELAY#########
set_input_delay  2 -max  -clock [get_clocks clk]  [get_ports key*]
set_input_delay  0 -min  -clock [get_clocks clk]  [get_ports key*]

set_output_delay  2 -max  -clock [get_clocks clk]  [get_ports text_out]
set_output_delay  0 -min  -clock [get_clocks clk]  [get_ports text_out]

set_max_fanout 32 [current_design]
########COMPILE########
compile_ultra
#########output#########
write -format verilog -hierarchy -output  ../output/aes_cipher_top_20240911_1100.v
write_sdc  ../output/aes_cipher_top_20240911_1100.sdc
write_file -format ddc -hierarchy -output ../output/aes_cipher_top_20240911_1100_compile.ddc
write_sdf  ../output/aes_cipher_top_20240911_1100.sdf
set_svf -off
########report########
report_area -nosplit -hierarchy                      > ../report/aes_cipher_top_20240911_1100_area.rpt
report_qor                                           > ../report/aes_cipher_top_20240911_1100_qor.rpt
report_timing -max_paths 10000                       >  ../report/aes_cipher_top_20240911_1100_report_timing.rpt
report_constraint -all_violators -nosplit            >  ../report/aes_cipher_top_20240911_1100_report_constraint.rpt
report_power                                         > ../report/aes_cipher_top_20240911_1100_power.rpt
